<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "sub_specialty".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "SubSpecialty".
 *
 * Columns in table "sub_specialty" available as properties of the model,
 * followed by relations of table "sub_specialty" available as properties of the model.
 *
 * @property integer $id
 * @property integer $specialty_id
 * @property string $name
 * @property string $taxonomy_code
 * @property string $description
 *
 * @property ProviderCertification[] $providerCertifications
 * @property ProviderSpecialty[] $providerSpecialties
 * @property SpecialtyCondition[] $specialtyConditions
 * @property SpecialtyMedication[] $specialtyMedications
 * @property SpecialtyTreatment[] $specialtyTreatments
 * @property Specialty $specialty
 */
abstract class BaseSubSpecialty extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'sub_specialty';
    }

    public static function representingColumn()
    {
        return 'name';
    }

    public function rules()
    {
        return array(
            array('specialty_id, name', 'required'),
            array('specialty_id', 'numerical', 'integerOnly' => true),
            array('name', 'length', 'max' => 100),
            array('taxonomy_code', 'length', 'max' => 10),
            array('description', 'safe'),
            array('generic_category', 'safe'),
            array('taxonomy_code, description', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, specialty_id, name, taxonomy_code, description', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'providerCertifications' => array(self::HAS_MANY, 'ProviderCertification', 'sub_specialty_id'),
            'providerSpecialties' => array(self::HAS_MANY, 'ProviderSpecialty', 'sub_specialty_id'),
            'specialtyConditions' => array(self::HAS_MANY, 'SpecialtyCondition', 'sub_specialty_id'),
            'specialtyMedications' => array(self::HAS_MANY, 'SpecialtyMedication', 'sub_specialty_id'),
            'specialtyTreatments' => array(self::HAS_MANY, 'SpecialtyTreatment', 'sub_specialty_id'),
            'specialty' => array(self::BELONGS_TO, 'Specialty', 'specialty_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'specialty_id' => Yii::t('app', 'Specialty'),
            'sub_specialty_id' => Yii::t('app', 'Sub Specialty'),
            'name' => Yii::t('app', 'Name'),
            'taxonomy_code' => Yii::t('app', 'Taxonomy Code'),
            'description' => Yii::t('app', 'Description'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        //this is to enable eager loading - don't add medication
        $criteria->with = array('specialty');

        //$criteria->compare('id', $this->id);
        $criteria->compare('specialty_id', $this->specialty_id);
        $criteria->compare('t.name', $this->name, true);
        $criteria->compare('taxonomy_code', $this->taxonomy_code, true);
        $criteria->compare('description', $this->description, true);
        $criteria->compare('generic_category', $this->generic_category, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'SubSpecialty|SubSpecialties', $n);
    }

}
